version: 1
name: kernel validation
description: Build and test linux kernel with every toolchain
jobs:
- name: armv5
  builds:
    - {toolchain: gcc-8, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: gcc-9, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: gcc-10, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: gcc-11, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: clang-10, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: clang-11, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: clang-12, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
    - {toolchain: clang-nightly, target_arch: arm, kconfig: [versatile_defconfig, "CONFIG_PCI=y", "CONFIG_PCI_VERSATILE=y", "CONFIG_SCSI=y", "CONFIG_BLK_DEV_SD=y", "CONFIG_SCSI_SYM53C8XX_2=y", "CONFIG_EXT4_FS=y"]}
  tests:
    - {device: qemu-armv5, tests: [ltp-fcntl-locktests]}
    - {device: qemu-armv5, tests: [ltp-fs_bind]}
    - {device: qemu-armv5, tests: [ltp-fsx]}
    - {device: qemu-armv5, tests: [ltp-nptl]}
    - {device: qemu-armv5, tests: [ltp-smoke]}
- name: armv7
  builds:
    - {toolchain: gcc-8, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: gcc-9, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: gcc-10, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: gcc-11, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: clang-10, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: clang-11, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: clang-12, target_arch: arm, kconfig: multi_v7_defconfig}
    - {toolchain: clang-nightly, target_arch: arm, kconfig: multi_v7_defconfig}
  tests:
    - {device: qemu-armv7, tests: [ltp-fcntl-locktests]}
    - {device: qemu-armv7, tests: [ltp-fs_bind]}
    - {device: qemu-armv7, tests: [ltp-fsx]}
    - {device: qemu-armv7, tests: [ltp-nptl]}
    - {device: qemu-armv7, tests: [ltp-smoke]}
- name: arm64
  builds:
    - {toolchain: gcc-8, target_arch: arm64, kconfig: defconfig}
    - {toolchain: gcc-9, target_arch: arm64, kconfig: defconfig}
    - {toolchain: gcc-10, target_arch: arm64, kconfig: defconfig}
    - {toolchain: gcc-11, target_arch: arm64, kconfig: defconfig}
    - {toolchain: clang-10, target_arch: arm64, kconfig: defconfig}
    - {toolchain: clang-11, target_arch: arm64, kconfig: defconfig}
    - {toolchain: clang-12, target_arch: arm64, kconfig: defconfig}
    - {toolchain: clang-nightly, target_arch: arm64, kconfig: defconfig}
  tests:
    - {device: qemu-arm64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-arm64, tests: [ltp-fs_bind]}
    - {device: qemu-arm64, tests: [ltp-fsx]}
    - {device: qemu-arm64, tests: [ltp-nptl]}
    - {device: qemu-arm64, tests: [ltp-smoke]}
- name: i386
  builds:
    - {toolchain: gcc-8, target_arch: i386, kconfig: defconfig}
    - {toolchain: gcc-9, target_arch: i386, kconfig: defconfig}
    - {toolchain: gcc-10, target_arch: i386, kconfig: defconfig}
    - {toolchain: gcc-11, target_arch: i386, kconfig: defconfig}
    - {toolchain: clang-10, target_arch: i386, kconfig: defconfig}
    - {toolchain: clang-11, target_arch: i386, kconfig: defconfig}
    - {toolchain: clang-12, target_arch: i386, kconfig: defconfig}
    - {toolchain: clang-nightly, target_arch: i386, kconfig: defconfig}
  tests:
    - {device: qemu-i386, tests: [ltp-fcntl-locktests]}
    - {device: qemu-i386, tests: [ltp-fs_bind]}
    - {device: qemu-i386, tests: [ltp-fsx]}
    - {device: qemu-i386, tests: [ltp-nptl]}
    - {device: qemu-i386, tests: [ltp-smoke]}
- name: mips64
  builds:
    - {toolchain: gcc-8, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64/malta_defconfig"]}
    - {toolchain: gcc-9, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64/malta_defconfig"]}
    - {toolchain: gcc-10, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64/malta_defconfig"]}
  tests:
    - {device: qemu-mips64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-mips64, tests: [ltp-fs_bind]}
    - {device: qemu-mips64, tests: [ltp-fsx]}
    - {device: qemu-mips64, tests: [ltp-nptl]}
    - {device: qemu-mips64, tests: [ltp-smoke]}
- name: mips64el
  builds:
    - {toolchain: gcc-8, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64el/malta_defconfig"]}
    - {toolchain: gcc-9, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64el/malta_defconfig"]}
    - {toolchain: gcc-10, target_arch: mips, kernel_image: vmlinux, kconfig: [malta_defconfig, "https://storage.tuxboot.com/mips64el/malta_defconfig"]}
  tests:
    - {device: qemu-mips64el, tests: [ltp-fcntl-locktests]}
    - {device: qemu-mips64el, tests: [ltp-fs_bind]}
    - {device: qemu-mips64el, tests: [ltp-fsx]}
    - {device: qemu-mips64el, tests: [ltp-nptl]}
    - {device: qemu-mips64el, tests: [ltp-smoke]}
- name: ppc64
  builds:
    - {toolchain: gcc-8, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_defconfig}
    - {toolchain: gcc-9, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_defconfig}
    - {toolchain: gcc-10, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_defconfig}
    - {toolchain: gcc-11, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_defconfig}
    - {toolchain: clang-nightly, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_defconfig}
  tests:
    - {device: qemu-ppc64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-ppc64, tests: [ltp-fs_bind]}
    - {device: qemu-ppc64, tests: [ltp-fsx]}
    - {device: qemu-ppc64, tests: [ltp-nptl]}
    - {device: qemu-ppc64, tests: [ltp-smoke]}
- name: ppc64le
  builds:
    - {toolchain: gcc-8, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_le_defconfig}
    - {toolchain: gcc-9, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_le_defconfig}
    - {toolchain: gcc-10, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_le_defconfig}
    - {toolchain: gcc-11, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_le_defconfig}
    - {toolchain: clang-nightly, target_arch: powerpc, kernel_image: vmlinux, kconfig: pseries_le_defconfig}
  tests:
    - {device: qemu-ppc64le, tests: [ltp-fcntl-locktests]}
    - {device: qemu-ppc64le, tests: [ltp-fs_bind]}
    - {device: qemu-ppc64le, tests: [ltp-fsx]}
    - {device: qemu-ppc64le, tests: [ltp-nptl]}
    - {device: qemu-ppc64le, tests: [ltp-smoke]}
- name: riscv64
  builds:
    - {toolchain: gcc-8, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: gcc-9, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: gcc-10, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: gcc-11, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: clang-10, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: clang-11, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: clang-12, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
    - {toolchain: clang-nightly, target_arch: riscv, kernel_image: Image, kconfig: defconfig}
  tests:
    - {device: qemu-riscv64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-riscv64, tests: [ltp-fs_bind]}
    - {device: qemu-riscv64, tests: [ltp-fsx]}
    - {device: qemu-riscv64, tests: [ltp-nptl]}
    - {device: qemu-riscv64, tests: [ltp-smoke]}
- name: sparc64
  builds:
    - {toolchain: gcc-8, target_arch: sparc, kernel_image: vmlinux, kconfig: [sparc64_defconfig]}
    - {toolchain: gcc-9, target_arch: sparc, kernel_image: vmlinux, kconfig: [sparc64_defconfig]}
    - {toolchain: gcc-10, target_arch: sparc, kernel_image: vmlinux, kconfig: [sparc64_defconfig]}
    - {toolchain: gcc-11, target_arch: sparc, kernel_image: vmlinux, kconfig: [sparc64_defconfig]}
  tests:
    - {device: qemu-sparc64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-sparc64, tests: [ltp-fs_bind]}
    - {device: qemu-sparc64, tests: [ltp-fsx]}
    - {device: qemu-sparc64, tests: [ltp-nptl]}
    - {device: qemu-sparc64, tests: [ltp-smoke]}
- name: x86_64
  builds:
    - {toolchain: gcc-8, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: gcc-9, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: gcc-10, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: gcc-11, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: clang-10, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: clang-11, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: clang-12, target_arch: x86_64, kconfig: defconfig}
    - {toolchain: clang-nightly, target_arch: x86_64, kconfig: defconfig}
  tests:
    - {device: qemu-x86_64, tests: [ltp-fcntl-locktests]}
    - {device: qemu-x86_64, tests: [ltp-fs_bind]}
    - {device: qemu-x86_64, tests: [ltp-fsx]}
    - {device: qemu-x86_64, tests: [ltp-nptl]}
    - {device: qemu-x86_64, tests: [ltp-smoke]}
